]> git.ipfire.org Git - thirdparty/git.git/blame - git-fetch.sh
Fix annotate test script; notice when git-annotate fails.
[thirdparty/git.git] / git-fetch.sh
CommitLineData
7ef76925
LT
1#!/bin/sh
2#
87358b7a
FK
3
4USAGE='<fetch-options> <repository> <refspec>...'
ae2b0f15 5. git-sh-setup
215a7ad1 6. git-parse-remote
853a3697
JH
7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
9
221e743c
JH
10LF='
11'
12IFS="$LF"
13
55b7835e 14rloga=fetch
03febf99 15no_tags=
ed1aadf1 16tags=
853a3697 17append=
ae2da406 18force=
583122cd 19verbose=
b10ac50f 20update_head_ok=
2c620a1a 21exec=
96b086d6 22upload_pack=
482faa8d 23keep=--thin
ae2da406
JH
24while case "$#" in 0) break ;; esac
25do
26 case "$1" in
27 -a|--a|--ap|--app|--appe|--appen|--append)
28 append=t
ae2da406 29 ;;
2796a9de
JH
30 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
31 --upload-pa|--upload-pac|--upload-pack)
2c620a1a
MO
32 shift
33 exec="--exec=$1"
96b086d6 34 upload_pack="-u $1"
2c620a1a 35 ;;
ae2da406
JH
36 -f|--f|--fo|--for|--forc|--force)
37 force=t
b10ac50f 38 ;;
ed1aadf1
LT
39 -t|--t|--ta|--tag|--tags)
40 tags=t
41 ;;
03febf99
JH
42 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
43 no_tags=t
44 ;;
b10ac50f
JH
45 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
46 --update-he|--update-hea|--update-head|--update-head-|\
47 --update-head-o|--update-head-ok)
48 update_head_ok=t
ae2da406 49 ;;
583122cd
LT
50 -v|--verbose)
51 verbose=Yes
52 ;;
0f76f526
TP
53 -k|--k|--ke|--kee|--keep)
54 keep=--keep
55 ;;
55b7835e
SP
56 --reflog-action=*)
57 rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
58 ;;
87358b7a
FK
59 -*)
60 usage
61 ;;
ae2da406
JH
62 *)
63 break
64 ;;
65 esac
b10ac50f 66 shift
ae2da406
JH
67done
68
853a3697
JH
69case "$#" in
700)
92c533ef
JH
71 test -f "$GIT_DIR/branches/origin" ||
72 test -f "$GIT_DIR/remotes/origin" ||
5e27e27e
SB
73 git-repo-config --get remote.origin.url >/dev/null ||
74 die "Where do you want to fetch from today?"
92c533ef 75 set origin ;;
853a3697 76esac
ae2da406 77
853a3697
JH
78remote_nick="$1"
79remote=$(get_remote_url "$@")
80refs=
81rref=
82rsync_slurped_objects=
83
55b7835e 84rloga="$rloga $remote_nick"
ed0e078f 85test "$remote_nick" = "$remote" || rloga="$rloga $remote"
55b7835e 86
853a3697
JH
87if test "" = "$append"
88then
df34297a 89 : >"$GIT_DIR/FETCH_HEAD"
853a3697
JH
90fi
91
92append_fetch_head () {
93 head_="$1"
94 remote_="$2"
95 remote_name_="$3"
96 remote_nick_="$4"
97 local_name_="$5"
05dd8e2e
JH
98 case "$6" in
99 t) not_for_merge_='not-for-merge' ;;
100 '') not_for_merge_= ;;
101 esac
853a3697 102
06ec2b4b
JH
103 # remote-nick is the URL given on the command line (or a shorthand)
104 # remote-name is the $GIT_DIR relative refs/ path we computed
105 # for this refspec.
687b8be8
EW
106
107 # the $note_ variable will be fed to git-fmt-merge-msg for further
108 # processing.
06ec2b4b
JH
109 case "$remote_name_" in
110 HEAD)
111 note_= ;;
112 refs/heads/*)
113 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
b91fb518 114 note_="branch '$note_' of " ;;
06ec2b4b
JH
115 refs/tags/*)
116 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
b91fb518 117 note_="tag '$note_' of " ;;
687b8be8
EW
118 refs/remotes/*)
119 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
120 note_="remote branch '$note_' of " ;;
06ec2b4b 121 *)
b91fb518 122 note_="$remote_name of " ;;
06ec2b4b 123 esac
f327dbce 124 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
b91fb518
JH
125 remote_="$remote_1_"
126 note_="$note_$remote_"
06ec2b4b 127
853a3697
JH
128 # 2.6.11-tree tag would not be happy to be fed to resolve.
129 if git-cat-file commit "$head_" >/dev/null 2>&1
130 then
8572aa85 131 headc_=$(git-rev-parse --verify "$head_^0") || exit
df34297a 132 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
583122cd
LT
133 [ "$verbose" ] && echo >&2 "* committish: $head_"
134 [ "$verbose" ] && echo >&2 " $note_"
853a3697 135 else
df34297a 136 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
583122cd
LT
137 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
138 [ "$verbose" ] && echo >&2 " $note_"
853a3697
JH
139 fi
140 if test "$local_name_" != ""
141 then
142 # We are storing the head locally. Make sure that it is
143 # a fast forward (aka "reverse push").
06ec2b4b 144 fast_forward_local "$local_name_" "$head_" "$note_"
853a3697
JH
145 fi
146}
147
148fast_forward_local () {
866ff2f7 149 mkdir -p "$(dirname "$GIT_DIR/$1")"
853a3697
JH
150 case "$1" in
151 refs/tags/*)
152 # Tags need not be pointing at commits so there
153 # is no way to guarantee "fast-forward" anyway.
ae2da406
JH
154 if test -f "$GIT_DIR/$1"
155 then
f8765797
JH
156 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
157 then
7eae7b99 158 [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
f8765797
JH
159 else
160 echo >&2 "* $1: updating with $3"
55b7835e 161 git-update-ref -m "$rloga: updating tag" "$1" "$2"
f8765797 162 fi
ae2da406 163 else
06ec2b4b 164 echo >&2 "* $1: storing $3"
55b7835e 165 git-update-ref -m "$rloga: storing tag" "$1" "$2"
ae2da406 166 fi
bf7960eb 167 ;;
ae2da406 168
687b8be8 169 refs/heads/* | refs/remotes/*)
bf7960eb
JH
170 # $1 is the ref being updated.
171 # $2 is the new value for the ref.
172 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
173 if test "$local"
33b83034 174 then
bf7960eb 175 # Require fast-forward.
853a3697
JH
176 mb=$(git-merge-base "$local" "$2") &&
177 case "$2,$mb" in
178 $local,*)
ea5aeb07
JH
179 if test -n "$verbose"
180 then
181 echo >&2 "* $1: same as $3"
182 fi
853a3697
JH
183 ;;
184 *,$local)
06ec2b4b 185 echo >&2 "* $1: fast forward to $3"
9d7f73d4 186 echo >&2 " from $local to $2"
55b7835e 187 git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
853a3697
JH
188 ;;
189 *)
190 false
191 ;;
192 esac || {
06ec2b4b 193 echo >&2 "* $1: does not fast forward to $3;"
bf7960eb
JH
194 case ",$force,$single_force," in
195 *,t,*)
06ec2b4b 196 echo >&2 " forcing update."
55b7835e 197 git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
ae2da406
JH
198 ;;
199 *)
bf7960eb 200 echo >&2 " not updating."
a9698bb2 201 exit 1
ae2da406
JH
202 ;;
203 esac
853a3697
JH
204 }
205 else
bf7960eb 206 echo >&2 "* $1: storing $3"
55b7835e 207 git-update-ref -m "$rloga: storing head" "$1" "$2"
33b83034 208 fi
0a623e7c 209 ;;
853a3697
JH
210 esac
211}
212
b10ac50f
JH
213case "$update_head_ok" in
214'')
bf7960eb 215 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
b10ac50f
JH
216 ;;
217esac
218
ed1aadf1
LT
219# If --tags (and later --heads or --all) is specified, then we are
220# not talking about defaults stored in Pull: line of remotes or
221# branches file, and just fetch those and refspecs explicitly given.
222# Otherwise we do what we always did.
223
224reflist=$(get_remote_refs_for_fetch "$@")
225if test "$tags"
226then
878ccb26 227 taglist=`IFS=" " &&
57a39690
JH
228 (
229 git-ls-remote $upload_pack --tags "$remote" ||
230 echo fail ouch
231 ) |
81214e4d
JH
232 while read sha1 name
233 do
57a39690
JH
234 case "$sha1" in
235 fail)
236 exit 1
237 esac
81214e4d 238 case "$name" in
878ccb26 239 *^*) continue ;;
81214e4d
JH
240 esac
241 if git-check-ref-format "$name"
242 then
243 echo ".${name}:${name}"
244 else
245 echo >&2 "warning: tag ${name} ignored"
246 fi
57a39690 247 done` || exit
ed1aadf1
LT
248 if test "$#" -gt 1
249 then
250 # remote URL plus explicit refspecs; we need to merge them.
221e743c 251 reflist="$reflist$LF$taglist"
ed1aadf1
LT
252 else
253 # No explicit refspecs; fetch tags only.
254 reflist=$taglist
255 fi
256fi
257
03febf99
JH
258fetch_main () {
259 reflist="$1"
260 refs=
f170e4b3 261
03febf99
JH
262 for ref in $reflist
263 do
264 refs="$refs$LF$ref"
f170e4b3 265
03febf99
JH
266 # These are relative path from $GIT_DIR, typically starting at refs/
267 # but may be HEAD
f327dbce 268 if expr "z$ref" : 'z\.' >/dev/null
03febf99
JH
269 then
270 not_for_merge=t
f327dbce 271 ref=$(expr "z$ref" : 'z\.\(.*\)')
03febf99
JH
272 else
273 not_for_merge=
274 fi
dfdcb558 275 if expr "z$ref" : 'z+' >/dev/null
03febf99
JH
276 then
277 single_force=t
dfdcb558 278 ref=$(expr "z$ref" : 'z+\(.*\)')
03febf99
JH
279 else
280 single_force=
281 fi
f327dbce
MW
282 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
283 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
853a3697 284
03febf99 285 rref="$rref$LF$remote_name"
4447badc 286
03febf99
JH
287 # There are transports that can fetch only one head at a time...
288 case "$remote" in
289 http://* | https://*)
290 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
291 curl_extra_args="-k"
292 fi
093b0688
NH
293 max_depth=5
294 depth=0
295 head="ref: $remote_name"
296 while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
297 do
d9bffc08 298 remote_name_quoted=$(@@PERL@@ -e '
03febf99 299 my $u = $ARGV[0];
093b0688 300 $u =~ s/^ref:\s*//;
03febf99
JH
301 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
302 print "$u";
093b0688
NH
303 ' "$head")
304 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
305 depth=$( expr \( $depth + 1 \) )
306 done
f327dbce 307 expr "z$head" : "z$_x40\$" >/dev/null ||
093b0688 308 die "Failed to fetch $remote_name from $remote"
03febf99
JH
309 echo >&2 Fetching "$remote_name from $remote" using http
310 git-http-fetch -v -a "$head" "$remote/" || exit
311 ;;
312 rsync://*)
313 TMP_HEAD="$GIT_DIR/TMP_HEAD"
314 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
315 head=$(git-rev-parse --verify TMP_HEAD)
316 rm -f "$TMP_HEAD"
317 test "$rsync_slurped_objects" || {
318 rsync -av --ignore-existing --exclude info \
319 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
853a3697 320
03febf99
JH
321 # Look at objects/info/alternates for rsync -- http will
322 # support it natively and git native ones will do it on
323 # the remote end. Not having that file is not a crime.
324 rsync -q "$remote/objects/info/alternates" \
325 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
326 rm -f "$GIT_DIR/TMP_ALT"
327 if test -f "$GIT_DIR/TMP_ALT"
328 then
329 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
330 while read alt
331 do
332 case "$alt" in 'bad alternate: '*) die "$alt";; esac
333 echo >&2 "Getting alternate: $alt"
334 rsync -av --ignore-existing --exclude info \
335 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
336 done
337 rm -f "$GIT_DIR/TMP_ALT"
338 fi
339 rsync_slurped_objects=t
340 }
341 ;;
342 *)
343 # We will do git native transport with just one call later.
344 continue ;;
345 esac
f170e4b3 346
03febf99
JH
347 append_fetch_head "$head" "$remote" \
348 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
853a3697 349
03febf99
JH
350 done
351
352 case "$remote" in
353 http://* | https://* | rsync://* )
354 ;; # we are already done.
355 *)
356 ( : subshell because we muck with IFS
357 IFS=" $LF"
358 (
482faa8d 359 git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
03febf99
JH
360 ) |
361 while read sha1 remote_name
362 do
363 case "$sha1" in
364 failed)
365 echo >&2 "Fetch failure: $remote"
366 exit 1 ;;
367 esac
368 found=
369 single_force=
370 for ref in $refs
371 do
372 case "$ref" in
373 +$remote_name:*)
374 single_force=t
375 not_for_merge=
376 found="$ref"
377 break ;;
378 .+$remote_name:*)
379 single_force=t
380 not_for_merge=t
381 found="$ref"
382 break ;;
383 .$remote_name:*)
384 not_for_merge=t
385 found="$ref"
386 break ;;
387 $remote_name:*)
388 not_for_merge=
389 found="$ref"
390 break ;;
391 esac
392 done
f327dbce 393 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
03febf99
JH
394 append_fetch_head "$sha1" "$remote" \
395 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
396 done
397 ) || exit ;;
398 esac
399
400}
401
402fetch_main "$reflist"
403
404# automated tag following
405case "$no_tags$tags" in
406'')
6dc78e69
JH
407 case "$reflist" in
408 *:refs/*)
409 # effective only when we are following remote branch
410 # using local tracking branch.
411 taglist=$(IFS=" " &&
412 git-ls-remote $upload_pack --tags "$remote" |
413 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
414 while read sha1 name
415 do
416 test -f "$GIT_DIR/$name" && continue
417 git-check-ref-format "$name" || {
418 echo >&2 "warning: tag ${name} ignored"
419 continue
420 }
421 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
422 echo >&2 "Auto-following $name"
423 echo ".${name}:${name}"
424 done)
425 esac
03febf99
JH
426 case "$taglist" in
427 '') ;;
428 ?*)
429 fetch_main "$taglist" ;;
430 esac
853a3697 431esac
b10ac50f
JH
432
433# If the original head was empty (i.e. no "master" yet), or
434# if we were told not to worry, we do not have to check.
435case ",$update_head_ok,$orig_head," in
436*,, | t,* )
437 ;;
438*)
bf7960eb 439 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
b10ac50f
JH
440 if test "$curr_head" != "$orig_head"
441 then
55b7835e
SP
442 git-update-ref \
443 -m "$rloga: Undoing incorrectly fetched HEAD." \
444 HEAD "$orig_head"
b10ac50f
JH
445 die "Cannot fetch into the current branch."
446 fi
447 ;;
448esac